Name: MAKEDEV
Version: 3.3.13
Release: 1m
Group: System Environment/Base
License: GPL
Source: MAKEDEV-%{version}-1.tar.gz
Source100: snddevices.in
Summary: A program used for creating the device files in /dev.
BuildRoot: %{_tmppath}/%{name}-%{version}-root
URL: http://www.lanana.org/docs/device-list/
PreReq: dev

Patch0: MAKEDEV.kondara.patch
Patch1: snddevices.safe.patch
Patch2: MAKEDEV-3.2-hubcot.patch
Patch4: MAKEDEV-3.3.13-libraw1394.patch
Patch5: MAKEDEV-3.3.13-sonypi.patch

%description
This package contains the MAKEDEV script, which makes it easier to create
and maintain the files in the /dev directory.  /dev directory files
correspond to a particular device supported by Linux (serial or printer
ports, scanners, sound cards, tape drives, CD-ROM drives, hard drives,
etc.) and interface with the drivers in the kernel.

You should install the MAKEDEV package because the MAKEDEV utility makes
it easy to manage the /dev directory device files.

%package -n dev
Group: System Environment/Base
Summary: The most commonly-used entries in the /dev directory.
Prereq: shadow-utils, fileutils, sed, textutils, mktemp

%description -n dev
The Red Hat Linux operating system uses file system entries to represent
devices (CD-ROMs, floppy drives, etc.) attached to the machine. All of
these entries are in the /dev tree (although they don't have to be).
This package contains the most commonly used /dev entries.

The dev package is a basic part of your Red Hat Linux system and it needs
to be installed.

%prep
%setup -q
%patch0 -p1
%patch2 -p1
%patch4 -p1
%patch5 -p1

%build
make OPTFLAGS="%{optflags}"

%install
mkdev() {
	%{buildroot}/dev/MAKEDEV -c %{buildroot}%{_sysconfdir}/makedev.d -d %{buildroot}/dev $@
}
makedev() {
	if [ `id -u` = 0 ] ; then
		# Note that we need to be the superuser for this to work at all.
		mkdev $@
	else
		# Note that we need RPM 4.0.3-0.71 or higher for this to be of any use!
		mkdev -M $@ | sed "s|%{buildroot}||g" >> manifest
	fi
}

rm -fr %{buildroot} manifest

%ifnarch s390 s390x
%makeinstall devdir=%{buildroot}/dev
makedev agpgart
makedev apm_bios
makedev beep
makedev capi20
makedev cdrom
makedev cfs
makedev compaq
makedev -m 32 console
makedev cpu
makedev -m 4 cua
makedev -m 16 cui
makedev dri
makedev -m 16 dv1394
makedev enskip
makedev fb
makedev fd0
makedev fd1
makedev ftape
makedev -m 2 ht
makedev -m 2 i2c
makedev i2o
makedev ibcs
makedev -m 33 ide
makedev initrd
makedev -m 32 input
makedev -m 16 ip
makedev -m 16 ipfilter
makedev ir
makedev -m 2 iscc
makedev -m 16 isdn
makedev -m 4 js
makedev -m 32 loop
makedev -m 1 log
makedev -m 8 lp
makedev md
makedev mouse
makedev -m 32 nb
makedev net/tun
makedev netlink
makedev -m 2 nht
makedev -m 4 nosst
makedev -m 16 nst
makedev -m 4 osst
makedev -m 8 par
makedev -m 4 pcd
makedev pd
makedev -m 4 pf
makedev -m 4 pg
makedev -m 4 ppp
makedev pt
makedev ptmx
makedev pty
makedev qng
makedev -m 20 ram
makedev random
makedev raid
makedev raw
makedev raw1394
makedev rmt
makedev rtc
makedev -m 8 scd
makedev -m 16 scramdisk
makedev sd
makedev -m 32 sg
makedev smpt
makedev sound
makedev -m 16 st
makedev systty
makedev -m 4 staliomem
makedev std
makedev tlk
makedev -m 32 tty
makedev urandom
makedev -m 32 usb
makedev -m 4 v4l
makedev vcs
makedev -m 16 video1394
makedev vmmon
makedev -m 4 vnet
makedev vsys
makedev -m 4 winradio
makedev xda
makedev xdb
pushd %{buildroot}/dev
ln -s ./video1394a video1394
ln -s ./dv1394a    dv1394
popd
%endif

%ifarch %ix86 athlon
makedev sonypi
%endif

%ifarch ia64
makedev efirtc
%endif

%ifarch ppc ppc64
makedev iseries
makedev nvram
makedev hvc0
%endif


install -m 744 %{SOURCE100} %{buildroot}/dev/snddevices
cd %{buildroot}/dev
patch -p0 < %{PATCH1}
rm -f *~
cd -

# If we're using a version of RPM which can't handle devices yet,
# generate a manifest using /dev.
if [ ! -f manifest ] ; then
	find %{buildroot}/dev -maxdepth 1 -mindepth 1 -not -name MAKEDEV -and -not -name log | \
	sed -e "s|%{buildroot}||g" > manifest
fi
grep -v '/dev/log$' manifest | sort -u > mdmanifest

# Make subdirectories we otherwise would have nothing to do with.
install -d -m 755 %{buildroot}/dev/pts
install -d -m 755 %{buildroot}/dev/shm

%clean
rm -fr %{buildroot}

%post
/dev/snddevices 2>&1 > /dev/null

%pre
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the %{name} package: mounted devfs detected."
		exit $MOUNTED
	fi
fi

%pre -n dev
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the dev package: mounted devfs detected."
		exit $MOUNTED
	fi
fi
if [ ! -d /dev ] ; then
	/bin/mkdir /dev
fi
/usr/sbin/groupadd -g 19 -r -f floppy > /dev/null 2>/dev/null ||:
exit 0

%post -n dev
if [ -x /sbin/pam_console_apply ] ; then
  /sbin/pam_console_apply
fi

%files
%defattr(-,root,root)
%doc COPYING devices.txt
/dev/MAKEDEV
%{_mandir}/man8/*
%{_sbindir}/mksock
%config %{_sysconfdir}/makedev.d

%files -n dev -f mdmanifest
%dir /dev
%ghost /dev/log
%dir /dev/pts
%dir /dev/shm

%changelog
* Sun May 23 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.3.13-1m)
- update to 3.3.13
- remove nvidia
- add cfs, cpu, net/tun, nosst, scramdisk, vsys
- add some arch depndent dev files

* Thu Aug 28 2002 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.3-6m)
- update snddevices.in from alsa-drivers 0.9.6

* Wed Jul 17 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.3-5m)
- add /dev/sonypi (c 10 250)

* Fri May 31 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.3-4k)
  remove defattr

* Sun May 12 2002 Toru Hoshina <t@kondara.org>
- (3.3-2k)
- ver up.

* Thu May  2 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.2-14k)
- suppress verbose messages at %post

* Wed May  1 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.2-12k)
- add PreReq: dev

* Tue Apr 30 2002 Kenta MURATA <muraken@kondara.org>
- (3.2-10k)
- /usr/sbin/groupadd -> shadow-utils in PreReq
- omit /bin/mkdir because it contained by fileutils.

* Thu Mar 14 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.2-8k)
  change video1394 (major: 172->171, minor: 0->16)
  add    dv1394    (major: 171, minor: 32)

* Mon Jan  7 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (3.2-6k)
- add nvidia

* Tue Nov 20 2001 Shingo Akagaki <dora@kondara.org>
- (3.2-4k)
- add hubcot

* Tue Oct  2 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.2-2k)
- merge to rh 3.2-5

* Thu Aug 30 2001 Nalin Dahyabhai <nalin@redhat.com>
- char 10/208 is cpqphpc, not cpqphpcp (#52910)
- add compaq/ devices (#52898)
- add information about raw1394 and video1394 devices (#52736)

* Fri Aug 17 2001 Karsten Hopp <karsten@redhat.de>
- add tape390 devices

* Tue Aug 14 2001 Karsten Hopp <karsten@redhat.de>
- clean up all those ifnarch s390 clauses

* Thu Aug  2 2001 Nalin Dahyabhai <nalin@redhat.com>
- bring in line with devices.txt from 3 June 2001
- create dri devices

* Wed Jul 18 2001 Tim Powers <timp@redhat.com>
- rebuilt using new rpm that actually does %%dev correctly

* Mon Jul 16 2001 Nalin Dahyabhai <nalin@redhat.com>
- tweak the manifest handling to also build when RPM doesn't know
  about them
- add a -S option to spit out shell script snippets
- only claim that we need to create a particular directory once
- fix descriptions for i2o/hdd[i-p], which were wrong
- break generic and architecture-specific sections apart in %%install

* Sun Jul 15 2001 Jeff Johnson <jbj@redhat.com>
- generate device manifest with MAKEDEV -M to build as non-root.

* Wed Jul 11 2001 Bill Nottingham <notting@redhat.com>
- add proper prereqs to dev package for %post (#48769)

* Thu Jul 05 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- disable unneeded parts of post for s390,s390x

* Sun Jul 01 2001 Karsten Hopp <karsten@redhat.de>
- S390-only changes -- added missing devices

* Fri Jun 29 2001 Karsten Hopp <karsten@redhat.de>
- added missing /dev/null on S390

* Wed Jun 27 2001 Nalin Dahyabhai <nalin@redhat.com>
- back out some changes, move documentation for dasd device numbers elsewhere

* Wed Jun 27 2001 Karsten Hopp <karsten@redhat.de>
- move 2 S390 patches into CVS, console-patch has to stay or it
  would break other archs

* Tue Jun 26 2001 Nalin Dahyabhai <nalin@redhat.com>
- create the first four /dev/osst devices (#35833)
- only 7 partitions for DAC960 disks, not 8 (#31484)
- add ataraid device nodes (#44807)
- add a "raid" alias for all raid devices (#33117)
- update the man page

* Tue Jun 26 2001 Bill Nottingham <notting@redhat.com>
- add /dev/shm to fstab too

* Thu Jun 22 2001 Nalin Dahyabhai <nalin@redhat.com>
- own %{_sysconfdir}/makedev.d in addition to files it contains

* Wed Jun 21 2001 Karsten Hopp <karsten@redhat.de>
- correct device naming and major/minor numbers on S390

* Fri Jun  8 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix a bug in creation of leading directories when a format specifier is
  included in the directory's name
- zero-fill the buffer before we pass it to readlink()
- don't try to create /dev/ixj*; the device isn't present in 2.4
- limit number of each device in /dev/input to 32

* Thu May 31 2001 Nalin Dahyabhai <nalin@redhat.com>
- increase the number of lp and parport devices from 3 to 8

* Thu May 24 2001 Nalin Dahyabhai <nalin@redhat.com>
- make apm devices (apm_bios)
- make fancy beeper device (beep)

* Wed Apr 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- only make devices for two floppy drives instead of eight
- limit the number of cui devices to 16 instead of 64
- limit the number isdn and ippp devices to 16
- limit the number of nb devices to 32 (matches md)
- limit the number of st and nst devices to 16

* Fri Mar 23 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make all devices for all RAID controllers again

* Mon Mar 12 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make aliases for ide5 through ide9
- limit the number of console and console-related devices to 32
- run pam_console_apply in the post, if it exists

* Mon Mar  5 2001 Nalin Dahyabhai <nalin@redhat.com> 
- use a file manifest

* Sat Mar  3 2001 Nalin Dahyabhai <nalin@redhat.com> 
- drop the number of hdX devices from 33 to 17, on advice from Andre Hedrick

* Thu Mar  1 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make js0, js1, js2, js3 symlinks into /dev/input so that all programs use
  the new input-core joystick driver instead of the old one

* Mon Feb 26 2001 Nalin Dahyabhai <nalin@redhat.com> 
- detect devfs in the MAKEDEV %%pre, too (#26110)
- fix message in the dev %%pre (#26110)

* Fri Feb 16 2001 Nalin Dahyabhai <nalin@redhat.com> 
- build the netlink device (#15785)

* Sun Feb 11 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- merge in s390 s390x support

* Tue Feb  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- fail to install if %%pre detects devfs

* Thu Jan 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- create /dev in the %%pre script; installing the dev package should fixup
  the permissions, and we can't redirect to /dev/null without it (#24392)

* Thu Jan 18 2001 Nalin Dahyabhai <nalin@redhat.com>
- make /dev/aio world-writable (info from Ben LeHaise)

* Wed Jan 17 2001 Nalin Dahyabhai <nalin@redhat.com>
- add device nodes using the new devices.txt for Linux 2.4.0, and check that
  file into the source tree to make tracking further changes simpler
- change Copyright: GPL to License: GPL
- add a very simple substitution macro facility for specifying ownership and
  permissions in a single place
- add code for creating sockets natively
- remove conflicting data for where /dev/ftape should point to
- remove all raid controller device nodes for second and additional controllers
  (they can be created with MAKEDEV)

* Tue Jan  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- make 32 partition devices for IDE disks instead of 16

* Tue Dec 12 2000 Nalin Dahyabhai <nalin@redhat.com>
- make some ppp devices

* Thu Oct 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- change vcs0 to vcs (ditto for vcsa0)

* Tue Sep 12 2000 Bill Nottingham <notting@redhat.com>
- fixes for some sparc devices that fell out

* Thu Aug 24 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- change some devices that could be used for dialing to root:uucp/0660 perms

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- up the number of SCSI CD-ROM devices we know about from 8 to 32, but only
  create 8 at build-time

* Wed Aug 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove both temp files generated in the %%post (#16325)

* Mon Aug 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- change the sense of sga/sg0 node/symlink stuff to match kernel docs (#16056)

* Wed Aug  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- add the netlink device, and mark it as undocumented (#15785)
- add /dev/log socket as a ghost using Erik's mksocket
- add in devices that start with "m"
- change /dev/i20 to /dev/i2o
- fix a parser bug

* Tue Aug  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- add cciss device nodes (#14878)

* Mon Aug  7 2000 Crutcher Dunnavant <crutcher@redhat.com>
- make the usb lp? devices group-owned by 'lp'

* Fri Jul 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- make floppy disk devices group-accessible by the floppy group

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- stop making bogus symlinks (#14225)
- add "console" alias for tty devices to match man page
- add "qic" alias for tape devices to match man page

* Mon Jul 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- change group of the "lp" devices to "lp"
- comment out the ACSI disks, which probably shouldn't have those names
- incorporate the release number into the tarball file name

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix symlink creation where both the link and a target are in a subdirectory
- add efirtc in its own "ia64" control file

* Wed Jul  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a -i flag so that I can test in a CVS checkout
- use correct IBCS compatibility device entries
- fix symlink creation so that it works as intended

* Tue Jul  4 2000 Matt Wilson <msw@redhat.com>
- moved the Prereq: /usr/sbin/groupadd from the MAKEDEV package to the
  dev package
- added the %%post script to the dev package to add devpts mounting

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the man page 644, not 755

* Mon Jun 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- update from 8 to 16 loop devices

* Mon Jun 26 2000 Nalin Dahyabhai <nalin@redhat.com>
- add input/mice and md devices to the dev package
- limit loop devices to 16 in config files (this is a hard-coded kernel limit)

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- add the "floppy" group to the system in the dev package's pre-install

* Mon Jun 11 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix a typo in the devices list
- move non-standard names from linux-2.2 list to redhat list

* Sat Jun 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- FHS packaging for a shiny new version
